/* Automatically generated from Squeak on #(12 November 2003 11:33:05 pm) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#ifdef SQUEAK_BUILTIN_PLUGIN
#undef EXPORT
// was #undef EXPORT(returnType) but screws NorCroft cc
#define EXPORT(returnType) static returnType
#endif

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)


/*** Constants ***/

/*** Variables ***/

#ifdef SQUEAK_BUILTIN_PLUGIN
extern
#endif
struct VirtualMachine* interpreterProxy;
static const char *moduleName =
#ifdef SQUEAK_BUILTIN_PLUGIN
	"FontPlugin 12 November 2003 (i)"
#else
	"FontPlugin 12 November 2003 (e)"
#endif
;

/*** Function Prototypes ***/
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int halt(void);
#pragma export on
EXPORT(int) initialiseModule(void);
#pragma export off
static int msg(char *s);
#pragma export on
EXPORT(int) primitiveCreateFont(void);
EXPORT(int) primitiveDestroyFont(void);
EXPORT(int) primitiveFontAscent(void);
EXPORT(int) primitiveFontDataSize(void);
EXPORT(int) primitiveFontDescent(void);
EXPORT(int) primitiveFontEmbeddingFlags(void);
EXPORT(int) primitiveFontEncoding(void);
EXPORT(int) primitiveFontFullWidthOfChar(void);
EXPORT(int) primitiveFontGetKernPair(void);
EXPORT(int) primitiveFontGlyphOfChar(void);
EXPORT(int) primitiveFontNumKernPairs(void);
EXPORT(int) primitiveFontWidthOfChar(void);
EXPORT(int) primitiveGetFontData(void);
EXPORT(int) primitiveListFont(void);
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
EXPORT(int) shutdownModule(void);
#pragma export off


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}

static int halt(void) {
	;
}


/*	Initialise the module */

EXPORT(int) initialiseModule(void) {
	return ioFontInit();
}

static int msg(char *s) {
	fprintf(stderr, "\n%s: %s", moduleName, s);
}

EXPORT(int) primitiveCreateFont(void) {
    int fontNameLength;
    int fontNameIndex;
    int fontFlags;
    int fontSize;
    int fontName;
    int fontID;

	if (!((interpreterProxy->methodArgumentCount()) == 3)) {
		return interpreterProxy->primitiveFail();
	}
	fontFlags = interpreterProxy->stackIntegerValue(0);
	fontSize = interpreterProxy->stackIntegerValue(1);
	fontName = interpreterProxy->stackObjectValue(2);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!(interpreterProxy->isBytes(fontName))) {
		return interpreterProxy->primitiveFail();
	}
	fontNameLength = interpreterProxy->byteSizeOf(fontName);
	fontNameIndex = ((int) (interpreterProxy->firstIndexableField(fontName)));
	fontID = ioCreateFont(fontNameIndex, fontNameLength, fontSize, fontFlags);
	if (fontID < 0) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(4);
	interpreterProxy->pushInteger(fontID);
}

EXPORT(int) primitiveDestroyFont(void) {
    int fontIndex;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!(ioDestroyFont(fontIndex))) {
		return interpreterProxy->primitiveFail();
	}
	return interpreterProxy->pop(1);
}

EXPORT(int) primitiveFontAscent(void) {
    int ascent;
    int fontIndex;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	ascent = ioFontAscent(fontIndex);
	if (!(ascent >= 0)) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(ascent);
}

EXPORT(int) primitiveFontDataSize(void) {
    int fontIndex;
    int size;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	size = ioGetFontDataSize(fontIndex);
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(size);
}

EXPORT(int) primitiveFontDescent(void) {
    int fontIndex;
    int descent;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	descent = ioFontDescent(fontIndex);
	if (!(descent >= 0)) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(descent);
}

EXPORT(int) primitiveFontEmbeddingFlags(void) {
    int flags;
    int fontIndex;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	flags = ioFontEmbeddingFlags(fontIndex);
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(flags);
}

EXPORT(int) primitiveFontEncoding(void) {
    int fontIndex;
    int encoding;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	encoding = ioFontEncoding(fontIndex);
	if (!(encoding >= 0)) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(encoding);
}

EXPORT(int) primitiveFontFullWidthOfChar(void) {
    int i;
    int charIndex;
    int fontIndex;
    int array;
    int fullWidth[3];

	if (!((interpreterProxy->methodArgumentCount()) == 2)) {
		return interpreterProxy->primitiveFail();
	}
	charIndex = interpreterProxy->stackIntegerValue(0);
	fontIndex = interpreterProxy->stackIntegerValue(1);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!(ioFontFullWidthOfChar(fontIndex, charIndex, fullWidth))) {
		return interpreterProxy->primitiveFail();
	}
	array = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 3);
	for (i = 0; i <= 2; i += 1) {
		interpreterProxy->storeIntegerofObjectwithValue(i, array, fullWidth[i]);
	}
	interpreterProxy->pop(3);
	return interpreterProxy->push(array);
}

EXPORT(int) primitiveFontGetKernPair(void) {
    int i;
    int kernIndex;
    int fontIndex;
    int kernPair[3];
    int array;

	if (!((interpreterProxy->methodArgumentCount()) == 2)) {
		return interpreterProxy->primitiveFail();
	}
	kernIndex = interpreterProxy->stackIntegerValue(0);
	fontIndex = interpreterProxy->stackIntegerValue(1);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!(ioFontGetKernPair(fontIndex, kernIndex, kernPair))) {
		return interpreterProxy->primitiveFail();
	}
	array = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 3);
	for (i = 0; i <= 2; i += 1) {
		interpreterProxy->storeIntegerofObjectwithValue(i, array, kernPair[i]);
	}
	interpreterProxy->pop(3);
	return interpreterProxy->push(array);
}

EXPORT(int) primitiveFontGlyphOfChar(void) {
    int ppw;
    int formWidth;
    int formBits;
    int charIndex;
    int pitch;
    int formOop;
    int formDepth;
    int formHeight;
    int fontIndex;

	if (!((interpreterProxy->methodArgumentCount()) == 3)) {
		return interpreterProxy->primitiveFail();
	}
	formOop = interpreterProxy->stackObjectValue(0);
	charIndex = interpreterProxy->stackIntegerValue(1);
	fontIndex = interpreterProxy->stackIntegerValue(2);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!((interpreterProxy->isPointers(formOop)) && ((interpreterProxy->slotSizeOf(formOop)) >= 4))) {
		return interpreterProxy->primitiveFail();
	}
	formBits = interpreterProxy->fetchPointerofObject(0, formOop);
	formWidth = interpreterProxy->fetchIntegerofObject(1, formOop);
	formHeight = interpreterProxy->fetchIntegerofObject(2, formOop);
	formDepth = interpreterProxy->fetchIntegerofObject(3, formOop);
	if (!((formWidth > 0) && ((formHeight > 0) && (formDepth > 0)))) {
		return interpreterProxy->primitiveFail();
	}
	ppw = 32 / formDepth;
	pitch = ((formWidth + (ppw - 1)) / ppw) * 4;
	if (!(((interpreterProxy->fetchClassOf(formBits)) == (interpreterProxy->classBitmap())) && ((interpreterProxy->byteSizeOf(formBits)) == (pitch * formHeight)))) {
		return interpreterProxy->primitiveFail();
	}
	formBits = ((int) (interpreterProxy->firstIndexableField(formBits)));
	if (!(ioFontGlyphOfChar(fontIndex, charIndex, formBits, formWidth, formHeight, formDepth))) {
		return interpreterProxy->primitiveFail();
	}
	return interpreterProxy->pop(3);
}

EXPORT(int) primitiveFontNumKernPairs(void) {
    int fontIndex;
    int nKernPairs;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	nKernPairs = ioFontNumKernPairs(fontIndex);
	if (!(nKernPairs >= 0)) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(2);
	return interpreterProxy->pushInteger(nKernPairs);
}

EXPORT(int) primitiveFontWidthOfChar(void) {
    int charIndex;
    int fontIndex;
    int charWidth;

	if (!((interpreterProxy->methodArgumentCount()) == 2)) {
		return interpreterProxy->primitiveFail();
	}
	charIndex = interpreterProxy->stackIntegerValue(0);
	fontIndex = interpreterProxy->stackIntegerValue(1);
	if (interpreterProxy->failed()) {
		return null;
	}
	charWidth = ioFontWidthOfChar(fontIndex, charIndex);
	if (!(charWidth >= 0)) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->pop(3);
	return interpreterProxy->pushInteger(charWidth);
}

EXPORT(int) primitiveGetFontData(void) {
    int fontIndex;
    char * bufPtr;
    int buffer;
    int result;
    int bufSize;

	if (!((interpreterProxy->methodArgumentCount()) == 2)) {
		return interpreterProxy->primitiveFail();
	}
	buffer = interpreterProxy->stackObjectValue(0);
	fontIndex = interpreterProxy->stackIntegerValue(1);
	if (interpreterProxy->failed()) {
		return null;
	}
	if (!(interpreterProxy->isBytes(buffer))) {
		return interpreterProxy->primitiveFail();
	}
	bufSize = interpreterProxy->byteSizeOf(buffer);
	bufPtr = interpreterProxy->firstIndexableField(buffer);
	result = ioGetFontData(fontIndex, bufPtr, bufSize);
	interpreterProxy->pop(3);
	return interpreterProxy->pushInteger(result);
}

EXPORT(int) primitiveListFont(void) {
    int i;
    char * fontPtr;
    int fontIndex;
    int fontOop;
    char * fontName;
    int fontNameLen;

	if (!((interpreterProxy->methodArgumentCount()) == 1)) {
		return interpreterProxy->primitiveFail();
	}
	fontIndex = interpreterProxy->stackIntegerValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	fontName = ioListFont(fontIndex);
	if (fontName == null) {
		interpreterProxy->pop(2);
		return interpreterProxy->push(interpreterProxy->nilObject());
	}
	fontNameLen = strlen(fontName);
	fontOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classString(), fontNameLen);
	fontPtr = interpreterProxy->firstIndexableField(fontOop);
	for (i = 0; i <= (fontNameLen - 1); i += 1) {
		fontPtr[i] = (fontName[i]);
	}
	interpreterProxy->pop(2);
	interpreterProxy->push(fontOop);
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
    int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}


/*	Initialise the module */

EXPORT(int) shutdownModule(void) {
	return ioFontShutdown();
}


#ifdef SQUEAK_BUILTIN_PLUGIN


void* FontPlugin_exports[][3] = {
	{"FontPlugin", "primitiveFontNumKernPairs", (void*)primitiveFontNumKernPairs},
	{"FontPlugin", "primitiveDestroyFont", (void*)primitiveDestroyFont},
	{"FontPlugin", "primitiveFontEncoding", (void*)primitiveFontEncoding},
	{"FontPlugin", "primitiveCreateFont", (void*)primitiveCreateFont},
	{"FontPlugin", "primitiveFontGetKernPair", (void*)primitiveFontGetKernPair},
	{"FontPlugin", "primitiveFontFullWidthOfChar", (void*)primitiveFontFullWidthOfChar},
	{"FontPlugin", "primitiveGetFontData", (void*)primitiveGetFontData},
	{"FontPlugin", "primitiveFontGlyphOfChar", (void*)primitiveFontGlyphOfChar},
	{"FontPlugin", "initialiseModule", (void*)initialiseModule},
	{"FontPlugin", "shutdownModule", (void*)shutdownModule},
	{"FontPlugin", "primitiveFontWidthOfChar", (void*)primitiveFontWidthOfChar},
	{"FontPlugin", "primitiveFontAscent", (void*)primitiveFontAscent},
	{"FontPlugin", "primitiveListFont", (void*)primitiveListFont},
	{"FontPlugin", "primitiveFontDescent", (void*)primitiveFontDescent},
	{"FontPlugin", "getModuleName", (void*)getModuleName},
	{"FontPlugin", "primitiveFontEmbeddingFlags", (void*)primitiveFontEmbeddingFlags},
	{"FontPlugin", "primitiveFontDataSize", (void*)primitiveFontDataSize},
	{"FontPlugin", "setInterpreter", (void*)setInterpreter},
	{NULL, NULL, NULL}
};


#endif /* ifdef SQ_BUILTIN_PLUGIN */

